#include "ti86asm.inc"

;__________________________________________________________________________;
;________________________________SHELL_____________________________________;
;__________________________________________________________________________;

.org _asm_exec_ram
    nop
	jp init
	.dw 1
	.dw shell
	.dw icon

;__________________________________________________________________________;
;_______________________________PROGRAM____________________________________;
;__________________________________________________________________________;

init:
	call _clrScrn
	call _runindicoff
	ld hl,$C9FA			;
	ld de,$C9FB			; This is for clear graph memory because there
	ld (hl),0			; is a bug in the ROM (v1.2).
	ld bc,1023			;
	ldir				;
	ld hl,$0303
	ld (_curRow),hl
	ld hl,nom
	call _puts
	ld h,1
	ld b,8
	ld c,15
	ld d,120
	ld e,47
	call drawbox
	ld b,10
	ld c,17
	ld d,118
	ld e,45
	call drawbox
	ld b,19
	ld c,24
	ld d,109
	ld e,28
	call drawbox 

contval1:
	ld b,18
	ld c,25
	ld d,18
	ld e,27
	ld a,($C008)
contval2:
	or a
	jr z,preloop
	dec a
	ld h,1
	inc b
	inc d
	call $4E51
	inc b
	inc d
	call $4E51
	inc b
	inc d
	call $4E51
	jr contval2

preloop:
	ld a,b
	ld (loc),a
loop:
	call _getky
	cp K_EXIT
	jr z,fin
	cp K_LEFT
	jr z,dec_contrast
	cp K_RIGHT
	jr nz,loop

inc_contrast:
	ld a,($C008)
	cp 30
	jr z,loop
	inc a
	ld ($C008),a
	out (2),a
	jr contval1

dec_contrast:
	ld a,($C008)
	or a
	jr z,loop
	dec a
	ld ($C008),a
	out (2),a
	ld a,(loc)
	ld h,0
	ld b,a
	ld d,b
	ld c,25
	ld e,27
	call $4E51
	dec b
	dec d
	call $4E51
	dec b
	dec d
	call $4E51
	dec b
	dec d
	jr preloop

drawbox: 		; In order to use this routine you have
	ld a,e		; to put the coordinates of 2 opposite 
	ld e,c		; point of the box in bc and de.
	call $4E51	; h = 1 for a black box
	ld e,a		; h = 1 for a white box
	ld a,c		; $4E51=_Iline ROM routine
	ld c,e
	call $4E51
	ld c,a
	ld a,d
	ld d,b
	call $4E51
	ld d,a
	ld a,b
	ld b,d
	call $4E51
	ret

fin:
	ld hl,$C9FA
	ld de,$C9FB
	ld (hl),0
	ld bc,1023
	ldir
	call _clrScrn 
	call _homeup
	ret

;__________________________________________________________________________;
;_________________________________OTHER____________________________________;
;__________________________________________________________________________;

loc:
	.db 0

shell:
.db "Contraste by Mansot Etienne",0

nom:
.db "-  CONTRASTE  +",0

icon:
.db 8,1
.db %11111111
.db %10000001
.db %10011101
.db %10100001
.db %10100001
.db %10011101
.db %10000001
.db %11111111

.end
